#include <View.h>
#include <Bitmap.h>
#include <Roster.h>
#include "IconView.h"

IconView::IconView(BRect workRect, BBitmap* normal, BBitmap* over, BBitmap* down, char* sig)
	:BView(workRect, NULL, B_FOLLOW_NONE, B_WILL_DRAW | B_FRAME_EVENTS | B_SUBPIXEL_PRECISE)
{
	normal_state = normal;
	switcher = normal_state;
	over_state = over;
	down_state = down;
	
	signature = sig;
}

void IconView::Draw(BRect updateRect)
{
	DrawBitmap(switcher, BPoint(0,0));
	BView::Draw(updateRect);
}

void IconView::MouseDown(BPoint where)
{
	switcher = down_state;
	Invalidate();
	
	BView::MouseDown(where);
	return;
}

void IconView::MouseUp(BPoint where)
{
	switcher = over_state;
	Invalidate();
	
	be_roster -> Launch(signature);
	BView::MouseUp(where);
	return;
}

void IconView::MouseMoved(BPoint where, uint32 state, const BMessage* message)
{
	switch(state)
	{
		case B_ENTERED_VIEW :
		{
			switcher = over_state;
			Invalidate();
			break;
		}
		
		case B_EXITED_VIEW :
		{
			switcher = normal_state;
			Invalidate();
			break;
		}
	}
	
	BView::MouseMoved(where, state, message);
	return;
}

IconView::~IconView()
{

}