#include <Window.h>
#include <Application.h>
#include <File.h>
#include <Alert.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "LaunchBarWindow.h"
#include "LaunchBar.h"

LaunchBarWindow::LaunchBarWindow()
	:BWindow(BRect(200,200,234,549), "LaunchBar", B_NO_BORDER_WINDOW_LOOK,
	 B_NORMAL_WINDOW_FEEL, B_NOT_RESIZABLE | B_WILL_ACCEPT_FIRST_CLICK | B_ASYNCHRONOUS_CONTROLS
	 | B_NOT_ZOOMABLE | B_NOT_MINIMIZABLE)
{
	GetDesktopBorders();
	if(ReadConfigScript())
	{
		view_app = new LaunchBarView(Bounds(), right, bottom, adresses, num_sign, bar_type);
		AddChild(view_app);
		view_app -> AttachedToWindow();
		
		Show();
	}
	else
		be_app -> PostMessage(B_QUIT_REQUESTED);
}

void LaunchBarWindow::GetDesktopBorders()
{
	right = 766; bottom = 251;
	current_screen = new BScreen(0);
	if(current_screen -> IsValid())
	{
		current_screen -> GetMode(&mode);
		right = mode.virtual_width;
		bottom = mode.virtual_height;
	}
}

int LaunchBarWindow::ReadConfigScript()
{
	off_t size; char* strp_buffer; 
	BFile script; 
	if(script.SetTo("/boot/home/config/settings/LaunchBar/config-script", B_READ_ONLY) == B_ENTRY_NOT_FOUND )
	{
		BAlert* nofile_alert = new BAlert("nofile alert", SpTranslate("You should create a valid configuration file before lauching LaunchBar. See the README file for more explanation."), "OK", NULL, NULL,B_WIDTH_AS_USUAL,
							B_INFO_ALERT);
		nofile_alert -> Go();
		return 0;
	}
	else
	{
		script.GetSize(&size);
		text_buffer = (char*)malloc((int)size);
		script.Read(text_buffer, (size_t) size);
	
///////////////////////////////////////////////////////// Definition du type de la barre ///////////////////////////////////////

		strp_buffer = bar_type;
		while (*text_buffer != ';') *strp_buffer++ = *text_buffer++; *strp_buffer = '\0';
		while(*text_buffer++ != 10);
		
		if(strcmp(bar_type, "big_size") == 0) ResizeTo(69, 599);
		
///////////////////////////////////////////////////////// Definiion de la position sur l'écran ////////////////////////////////
	
		num_add_x = 0; num_add_y = 0;
		num_add_x = atoi(text_buffer);
		while(*text_buffer++ != 'x');
		num_add_y = atoi(text_buffer);
		while(*text_buffer++ != 10);
		MoveTo(num_add_x, num_add_y);	

///////////////////////////////////////////////////////// Definition des signatures //////////////////////////////////////////////

		num_sign = 0;
		num_sign = atoi(text_buffer);
		while(*text_buffer++ != 10);
		for(int i = 0; i != num_sign; i++)
		{
			adresses[i] = (char*)malloc(100);
			strp_buffer = adresses[i];
			while (*text_buffer != ';') *strp_buffer++ = *text_buffer++; *strp_buffer = '\0';
			while ((*text_buffer != '\0')&&(*(text_buffer-1) != 10)) text_buffer += 1;
		}
		return 1;
	}	
}
	
		
LaunchBarWindow::~LaunchBarWindow()
{

}